package com.ruoyi.ss.payBill.service.impl;

import com.ruoyi.ss.payBill.domain.PayBill;
import com.ruoyi.ss.payBill.domain.PayBillVO;
import com.ruoyi.ss.payBill.domain.enums.PayBillBstType;
import com.ruoyi.ss.payBill.domain.enums.PayBillStatus;
import com.ruoyi.ss.payBill.service.PayBillConverter;
import com.ruoyi.ss.timeBill.domain.TimeBill;
import com.ruoyi.ss.transactionBill.domain.enums.TransactionBillPayType;
import com.ruoyi.ss.user.domain.SmUserVo;
import com.ruoyi.ss.user.service.ISmUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wjh
 * 2024/8/9
 */
@Service
public class PayBillConverterImpl implements PayBillConverter {

    @Autowired
    private ISmUserService userService;

    @Override
    public PayBill toPo(TimeBill bill, Long channelId) {
        if (bill == null) {
            return null;
        }

        PayBill po = new PayBill();

        // 查询用户
        SmUserVo user = userService.selectSmUserByUserId(bill.getUserId());
        if (user == null) {
            return null;
        }

        // 若关闭成功，创建支付订单
        PayBillVO data = new PayBillVO();
        data.setBstType(PayBillBstType.TIME_BILL.getType());
        data.setBstId(bill.getBillId());
        data.setAmount(bill.getAmount());
        data.setChannelId(channelId);
        data.setStatus(PayBillStatus.WAIT_PAY.getStatus());
        data.setDescription("计时订单" + bill.getBillNo());

        // TODO 渠道成本及服务费

        // 支付人
        if (TransactionBillPayType.WECHAT.getType().equals(data.getChannelId())) {
            data.setAccount(user.getWxOpenId());
        }
        return po;
    }
}
